const reminderFox_nsIFilePicker = Components.interfaces.nsIFilePicker;
const g_reminderFoxBundle = document.getElementById("reminderFox-bundle");  
const filterCalendar    =g_reminderFoxBundle.getString("rf.options.filepicker.filter.calendar");
const filterSound    =g_reminderFoxBundle.getString("rf.options.filepicker.filter.sound");

const extensionCalendar = ".ics"; 
const extensionSound= ".wav"; 
var reminderFox_mPositionMax;

function reminderFox_loadOptions() {	
	var showStatus = REMINDER_FOX_SHOW_STATUS_TEXT_DEFAULT;			
	try {
		showStatus = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_STATUS_TEXT);
	} catch(e) {
	}			
	document.getElementById("reminderFox-statustext").setAttribute("checked", showStatus);

	var showRemindersInTooltip = REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP_DEFAULT;			
	try {
		showRemindersInTooltip = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP);
	} catch(e) {
	}			
	document.getElementById("reminderFox-showRemindersTooltip").setAttribute("checked", showRemindersInTooltip);

	var showTodosInTooltip = REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP_DEFAULT;			
	try {
		showTodosInTooltip = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP);
	} catch(e) {
	}			
	document.getElementById("reminderFox-showTodosTooltip").setAttribute("checked", showTodosInTooltip);
	
	var upcomingDays = UPCOMING_REMINDER_DAYS_DEFAULT;
	try {
		upcomingDays = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + UPCOMING_REMINDER_DAYS_PREF);
	} catch(e) {
	}
	document.getElementById("remindersUpcomingDays").setAttribute("value", upcomingDays);


	var defaultEditType = REMINDER_FOX_DEFAULT_EDIT_DEFAULT;			
	try {
		defaultEditType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_EDIT);
	} catch(e) {
	}	
	
	var defaultEdit = document.getElementById("reminderFox-default-doubleclick");	
	if ( defaultEditType == "todos" ) {
		defaultEdit.selectedIndex = 1; 
	}
	else {
		defaultEdit.selectedIndex = 0; 
	}
	
	
	var alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
	try {
		alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
	} catch(e) {
	}
						
	var showAlert = document.getElementById("reminderFox-showAlert");	
	
	// if the user has set it to no alerts, the option should be disabled
	if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_NONE ) {
		showAlert.setAttribute("checked", "false");	    
	}
	else {
		showAlert.setAttribute("checked", "true");	    
		
		if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_ALL ) {  
			document.getElementById("reminderFox-alertList").selectedIndex = 0;
		}
		else if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_TODAY ) {  
			document.getElementById("reminderFox-alertList").selectedIndex = 1;		
		}
		else if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING ) {  
				document.getElementById("reminderFox-alertList").selectedIndex = 2;
		}
	}
	
	var alertTimeout = REMINDER_FOX_ALERT_TIMEOUT_DEFAULT;
	try {
		alertTimeout = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF);
	} catch(e) {
	}
	document.getElementById("reminderFox-alertTimeout").setAttribute("value", alertTimeout);

	var upcomingLabel = REMINDER_FOX_UPCOMING_REMINDERS_LABEL_DEFAULT;
	try {
		upcomingLabel = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_UPCOMING_REMINDERS_LABEL);
	} catch(e) {
	}
	document.getElementById("upcomingLabelOptions").setAttribute("value", upcomingLabel);
	
	var todaysLabel = REMINDER_FOX_TODAYS_REMINDERS_LABEL_DEFAULT;
	try {
		todaysLabel = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TODAYS_REMINDERS_LABEL);
	} catch(e) {
	}
	document.getElementById("todaysLabelOptions").setAttribute("value", todaysLabel);	
	
	var playSound = true;
	try {
		playSound = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_ALARM_SOUND);
	}
	catch ( e) {
	}
	
	var playSoundAlert = true;
	try {
		playSoundAlert = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_ALERT_SOUND);
	}
	catch ( e) {
	}
	
	document.getElementById("reminderFox-alarmSound").setAttribute("checked", playSound );	
	document.getElementById("reminderFox-alertSound").setAttribute("checked", playSoundAlert );	
	var soundFilePath = "";
	// check if user has specified a specific file path for sound in their preferences
	try {
		soundFilePath = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALARM_SOUND_PATH);
	}
	catch ( e) {
	}

	document.getElementById("reminderFox-alarm-sound-text-position").setAttribute("value", soundFilePath);
    var group = document.getElementById("reminderFox-alarmSound-group-position");    
	if ( soundFilePath == null || soundFilePath == "" ) {
	    group.selectedIndex = 0;
	}
	else {
	 	group.selectedIndex = 1;
	}
		
	var savefilePath;
	// check if user has specified a specific file path in their preferences
	try {
		savefilePath = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_STORE_FILE);
	}
	catch ( e) {
	}
	// if not, then use default location in profile
	if ( savefilePath == null || savefilePath == "" ) {
		document.getElementById("reminderFox-use-default-file-location").setAttribute("checked", true);		
	}
	else {
		document.getElementById("reminderFox-use-default-file-location").setAttribute("checked", false);
	}
	document.getElementById("reminderFox-file-location").setAttribute("value", reminderFox_getReminderStoreFile().path);
	reminderFox_fileLocationChanged();


	var networkSync = REMINDER_FOX_NETWORK_SYNCHRONIZE_DEFAULT;;			
	try {
		networkSync = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_NETWORK_SYNCHRONIZE);
	} catch(e) {
	}			
	document.getElementById("reminderFox-network-sync").setAttribute("checked", networkSync);

	
	// load settings of remote synchronization
	var proto = REMINDER_FOX_DEFAULT_PROTO;			
	try {
		proto = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_PROTO);
	} catch(e) {
	}	

	var protoMenu = document.getElementById("reminderFox-proto");	
	if ( proto == "ftp" ) {
		protoMenu.selectedIndex = 0; 
	} else if ( proto == "http" ) {
		protoMenu.selectedIndex = 1; 
	}
	else {
		protoMenu.selectedIndex = 2; 
	}

	var address = "";
	try {
		address = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ADDRESS);
	} catch(e) {
	}
	document.getElementById("reminderFox-text-address").setAttribute("value", address);

	var _username = "";
	try {
		_username = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USERNAME);
	} catch(e) {
	}
	document.getElementById("reminderFox-text-username").setAttribute("value", _username);


	var loginData = {
	    ljURL : proto + "://" + address,
	    username : _username,
	    password : ''
	};

	loginData = getPassword(loginData);
	if (loginData != null) {
		document.getElementById("reminderFox-text-password").setAttribute("value", loginData.password);
	}
	// end network
	
	
	
	reminderFox_populateBars();
	reminderFox_populatePositions();

	reminderFox_alertChanged();
	reminderFox_groupPositionChanged();
	reminderFox_alarmSoundChanged();	
	reminderFox_alarmSoundGroupPositionChanged();	
	reminderFox_fileLocationChanged();
	reminderFox_ValidateSynchronization();
	
}

function reminderFox_fileLocationChanged() {
	var fileLocationChanged = "true";
	try {
		fileLocationChanged = document.getElementById("reminderFox-use-default-file-location").getAttribute("checked" );
	}
	catch(e) {
	}		
	
	if ( fileLocationChanged == false || fileLocationChanged == "false") {
			document.getElementById("reminderFox-file-location").removeAttribute("disabled" );			
			document.getElementById("reminderFox_file_location_browse").removeAttribute("disabled" );						
	}
	else {
			document.getElementById("reminderFox-file-location").setAttribute("disabled", "true");			
			document.getElementById("reminderFox_file_location_browse").setAttribute("disabled", "true");						
	}
}	
	

function reminderFox_updateOptions() {					
	var showStatusText = "true";
	try {
		showStatusText = document.getElementById("reminderFox-statustext").getAttribute("checked" );
	}
	catch(e) {
	}		

	try {
		if ( showStatusText != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_STATUS_TEXT, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_STATUS_TEXT, true);
		}
	} catch(e) {
	}	
		
	var showRemindersInTooltip =	"true";
	try {
		showRemindersInTooltip =	document.getElementById("reminderFox-showRemindersTooltip").getAttribute("checked" );
	}
	catch(e) {
	}		
	try {
		if ( showRemindersInTooltip != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP, true);
		}
	} catch(e) {
	}	
	
	
	var networkSync =	"true";;
	try {
		networkSync =	document.getElementById("reminderFox-network-sync").getAttribute("checked" );
	}
	catch(e) {
	}		
	try {
		if ( networkSync != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_NETWORK_SYNCHRONIZE, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_NETWORK_SYNCHRONIZE, true);
		}
	} catch(e) {
	}	
	
	var showTodosInTooltip =	"true";
	try {
		showTodosInTooltip =	document.getElementById("reminderFox-showTodosTooltip").getAttribute("checked" );
	}
	catch(e) {
	}	
	try {
		if ( showTodosInTooltip != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP, true);
		}
	} catch(e) {
	}	
		
	var upcomingDays =UPCOMING_REMINDER_DAYS_DEFAULT + "";
	try {
		upcomingDays = document.getElementById("remindersUpcomingDays").value;
	}
	catch(e) {
	}		
	try {
			reminderFox_prefsBranch.setIntPref(UPCOMING_REMINDER_DAYS_PREF, upcomingDays);
	} catch(e) {
	}		
		
	var defaultEditIndex = 0;
	try {
		defaultEditIndex = document.getElementById("reminderFox-default-doubleclick").selectedIndex;
	}
	catch(e) {
	}		
	if ( defaultEditIndex == 1 ) {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_DEFAULT_EDIT, "todos");
	}
 	else {
 			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_DEFAULT_EDIT, "reminders");	
 	}		

	var showAlertVal =  true;
	try {
		var showAlert = document.getElementById("reminderFox-showAlert");	
		showAlertVal =  showAlert.getAttribute("checked" );
	}
	catch(e) {
	}	

	var alarmSound = document.getElementById("reminderFox-alarmSound");	
	var alarmSoundVal =  alarmSound.getAttribute("checked" );
	
	var alarmSoundAlert = document.getElementById("reminderFox-alertSound");	
	var alarmSoundAlertVal =  alarmSoundAlert.getAttribute("checked" );	
	
	var alarmEnabled = false;
	var alertEnabled = false;
	if ( alarmSoundVal == false || alarmSoundVal == "false") {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_ALARM_SOUND, false);
	}
	else {
			alarmEnabled = true;
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_ALARM_SOUND, true);
	}
	if ( alarmSoundAlertVal == false || alarmSoundAlertVal == "false") {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_ALERT_SOUND, false);
	}	
	else {
		alertEnabled = true;
		reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_ALERT_SOUND, true);
	}
	if ( alarmEnabled ||  alertEnabled ) {
	    	var group = document.getElementById("reminderFox-alarmSound-group-position");    
		    if ( group.selectedIndex == 0 ) {	
		    	reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ALARM_SOUND_PATH, "");
		    }
		    else {
				var customAlaramFileLocation = document.getElementById("reminderFox-alarm-sound-text-position").value;
				reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ALARM_SOUND_PATH, customAlaramFileLocation);
			}
	}

	try {
		reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALARM_SOUND_PATH);
	} catch(e) {
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ALARM_SOUND_PATH, REMINDER_FOX_ALARM_SOUND_PATH__DEFAULT);
	}		
	

	var fileLocationChanged = "true";
	try {
		fileLocationChanged = document.getElementById("reminderFox-use-default-file-location").getAttribute("checked" );
	}
	catch(e) {
	}		
	if ( fileLocationChanged == false || fileLocationChanged == "false") {
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_STORE_FILE, 	 document.getElementById("reminderFox-file-location").value);						
	}
	else {
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_STORE_FILE, 	"");					
	}
	

	if ( showAlertVal == false  || showAlertVal == "false") {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_NONE);
	}
	else {
		var alertIndex =0;
		try {
			alertIndex = document.getElementById("reminderFox-alertList").selectedIndex;
		}
		catch(e) {
		}		
		try {
			if ( alertIndex == 0 ) {
					reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_ALL);
			}
			if ( alertIndex == 1 ) {
					reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_TODAY);
			}
			if ( alertIndex == 2 ) {
					reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING);
			}	
		}
		catch( e ) {
		}	
	
	}
	
	
	var oldAlertTimeout;
	try {
		oldAlertTimeout = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF);
	} catch(e) {
	}
	
	var alertTimeout = REMINDER_FOX_ALERT_TIMEOUT_DEFAULT + "";
	try {
		alertTimeout = document.getElementById("reminderFox-alertTimeout").value;
	}
	catch(e) {
	}		
	try {
			reminderFox_prefsBranch.setIntPref(REMINDER_FOX_ALERT_TIMEOUT_PREF, alertTimeout);
	} catch(e) {
	}	

	if ( oldAlertTimeout != alertTimeout ){
		// need to clear the last alert in the case where alert timeout preference was changed 
		try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_LAST_ALERT, "");	
		} catch(e) {
		}		
	}
	
	var position =-1;
	var positionText;;
	try {
		position = document.getElementById("reminderFox-group-position");
		positionText = document.getElementById("reminderFox-text-position");
	}
	catch(e) {
	}	
	try {
	    if (parseInt(position.selectedItem.value) == -1)
	      reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, -1);
	    else  {    
	        var textPosition = document.getElementById("reminderFox-text-position");
		    if (textPosition.value < 0 || textPosition.value > reminderFox_mPositionMax) {
		      reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, -1);
		     }
		     else {
	    		reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, positionText.value);
	    	}      
	     }
     }
     catch(e) {
     }
	
	var toolbars = REMINDER_FOX_TOOLBAR_DEFAULT;
	try {
		 toolbars = document.getElementById("reminderFox-list-bars");
	}
   catch(e) {
	}	
	try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_TOOLBAR, toolbars.selectedItem.value);
	}
	catch(e) {
	}	
	

	try {
		var newLabel = document.getElementById("upcomingLabelOptions").value;
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_UPCOMING_REMINDERS_LABEL, newLabel);	
	} catch(e) {
	}	
	
	try {
		var newLabel = document.getElementById("todaysLabelOptions").value;
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_TODAYS_REMINDERS_LABEL, newLabel);	
	} catch(e) {
	}	
	

	// save of remote file options
	reminderFox_saveNetworkOptions();
	// end network
	
}

function reminderFox_saveNetworkOptions() {
	var protoIndex = 0;
	var proto = '';
	try {
		protoIndex = document.getElementById("reminderFox-proto").selectedIndex;
	}
	catch(e) {
	}		
	if ( protoIndex == 0 ) {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_PROTO, "ftp");
			proto = "ftp://";
	}else if ( protoIndex == 1 ) {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_PROTO, "http");
			proto = "http://";
	}
 	else {
 			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_PROTO, "https");	
			proto = "https://";
 	}	

	var address = "";
	try {
		address = document.getElementById("reminderFox-text-address").value;
	}
	catch(e) {
	}		
	try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ADDRESS, address);
	} catch(e) {
	}

	var _username = "";
	try {
		_username = document.getElementById("reminderFox-text-username").value;
	}
	catch(e) {
	}		
	try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_USERNAME, _username);
	} catch(e) {
	}

	var _password = "";
	try {
		_password = document.getElementById("reminderFox-text-password").value;
	}
	catch(e) {
	}		
	if (_password != '') {
		var loginData = {
		    ljURL : proto + address,
		    username : _username,
		    password : _password,
		    savePassword : true
		};
		savePassword(loginData);
	}	

}
function reminderFox_saveOptions() {
	if ( document.getElementById("reminderFox-apply").getAttribute("disabled" ) != true &&
		document.getElementById("reminderFox-apply").getAttribute("disabled" ) != "true" ) {
		reminderFox_updateOptions();
		reminderFox_updateWindows();
	}		
	document.getElementById("reminderFox-apply").setAttribute("disabled", true);
}

function reminderFox_saveOptionsAndClose() {

	reminderFox_updateOptions();
	window.close();
	if ( document.getElementById("reminderFox-apply").getAttribute("disabled" ) != true &&
		document.getElementById("reminderFox-apply").getAttribute("disabled" ) != "true" ) {
		reminderFox_updateWindows();
	}
}

function reminderFox_updateWindows() {
	try { 
		// update all of the browsers
		var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
		var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);	
		var windowEnumerator =  reminderFox_getWindowEnumerator();
		while (windowEnumerator.hasMoreElements()) {
			var currentWindow = windowEnumerator.getNext();		
			currentWindow.reminderFox_moveBox();
			currentWindow.reminderFox_updateRemindersInWindow();			
			currentWindow.reminderFox_clearRemindersAndTodos();
		}
	}
	catch( e ) {
	}
}


function reminderFox_updateButtons(aEvent)
{
  // don't enable the apply button for button presses
  if (aEvent) { 
    if ((aEvent.originalTarget.localName == "button") ||
        (aEvent.originalTarget.getAttribute("type") == "prof")) {
   	 return;
    }
  }

  document.getElementById("reminderFox-apply").removeAttribute("disabled");
}

function reminderFox_alertChanged() {
	var showAlert = document.getElementById("reminderFox-showAlert");	
	var showAlertVal =  showAlert.getAttribute("checked" );
	if ( showAlertVal == false || showAlertVal == "false") {
			document.getElementById("reminderFox-alertTimeout").setAttribute("disabled", "true");
			document.getElementById("reminderFox-alertList").setAttribute("disabled", "true");
			document.getElementById("reminderFox-showAlert1").setAttribute("disabled", "true");
			document.getElementById("reminderFox-showAlert2").setAttribute("disabled", "true");			
			document.getElementById("reminderFoxDisplay").setAttribute("disabled", "true");			
	}
	else {
			document.getElementById("reminderFox-alertTimeout").removeAttribute("disabled" );
			document.getElementById("reminderFox-alertList").removeAttribute("disabled" );
			document.getElementById("reminderFox-showAlert1").removeAttribute("disabled" );
			document.getElementById("reminderFox-showAlert2").removeAttribute("disabled" );
			document.getElementById("reminderFoxDisplay").removeAttribute("disabled" );
	}
	
}	

function reminderFox_alarmSoundChanged() {
	var alarmSound = document.getElementById("reminderFox-alarmSound");	
	var alarmSoundVal =  alarmSound.getAttribute("checked" );
	var alertSound = document.getElementById("reminderFox-alertSound");	
	var alertSoundVal =  alertSound.getAttribute("checked" );	
	if ( (alarmSoundVal == false || alarmSoundVal == "false") && (alertSoundVal == false || alertSoundVal == "false")) {
			document.getElementById("reminderFox-alarmSound-group-position").setAttribute("disabled", "true");
			document.getElementById("sound1").setAttribute("disabled", "true");			
			document.getElementById("sound2").setAttribute("disabled", "true");						
			document.getElementById("reminderFox-alarm-sound-text-position").setAttribute("disabled", "true");
			document.getElementById("reminderFox_sound_browse").setAttribute("disabled", "true");
	}
	else {
			document.getElementById("reminderFox-alarmSound-group-position").removeAttribute("disabled" );
			document.getElementById("sound1").removeAttribute("disabled" );			
			document.getElementById("sound2").removeAttribute("disabled" );						
			document.getElementById("reminderFox-alarm-sound-text-position").removeAttribute("disabled" );
			document.getElementById("reminderFox_sound_browse").removeAttribute("disabled" );
			reminderFox_alarmSoundGroupPositionChanged();			
	}
}	


function reminderFox_groupPositionChanged() {
    var text = document.getElementById("reminderFox-text-position");
    var textValid = document.getElementById("reminderFox-text-position-valid");
    var group = document.getElementById("reminderFox-group-position");    
    
    if ( group.selectedIndex == 0 ) {
    	text.setAttribute("disabled", "true");
    	textValid.setAttribute("disabled", "true");    
    }
    else {
    	text.removeAttribute("disabled" );
    	textValid.removeAttribute("disabled" );
    }
}	


function reminderFox_alarmSoundGroupPositionChanged() {
    var text = document.getElementById("reminderFox-alarm-sound-text-position");
    var group = document.getElementById("reminderFox-alarmSound-group-position");    
 	  var button = document.getElementById("reminderFox_sound_browse"); 
    
    if ( group.selectedIndex == 0 ) {
    	text.setAttribute("disabled", "true");
    	button.setAttribute("disabled", "true");
    }
    else {
		var alarmSound = document.getElementById("reminderFox-alarmSound");	
		var alarmSoundVal =  alarmSound.getAttribute("checked" );
		var alertSound = document.getElementById("reminderFox-alertSound");	
		var alertSoundVal =  alertSound.getAttribute("checked" );	
		if ( (alarmSoundVal == false || alarmSoundVal == "false") && (alertSoundVal == false || alertSoundVal == "false")) {    
		    text.setAttribute("disabled", "true");
    		button.setAttribute("disabled", "true");    
		}
		else {
	    	text.removeAttribute("disabled" );
	    	button.removeAttribute("disabled" );    	
	    }
    }
}	

function reminderFox_exportReminders() { 
	var i;
	
	// escape all commas
	var reminderFoxEvents = reminderFox_getReminderEvents();
	for ( i = 0; i < reminderFoxEvents.length; i++ ) {
		reminderFoxEvents[i].summary = reminderFoxEvents[i].summary.replace(/,/g,"\\,")
	}
	var reminderFoxTodos = reminderFox_getReminderTodos();
	for ( i = 0; i < reminderFoxTodos.length; i++ ) {
		reminderFoxTodos[i].summary = reminderFoxTodos[i].summary.replace(/,/g,"\\,")
	}


	var outputStr = reminderFox_constructReminderOutput(reminderFoxEvents, reminderFoxTodos, false);

    //get file
    var file = reminderFox_filePickerExport(0, window);
    if (!file)
      return;	
      
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to save file was denied.");
	}

	if ( file.exists() == false ) {
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
	}      
	
	reminderFox_writeStringToFile(outputStr, file);

	// show success message
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);
	promptService.alert(window,g_reminderFoxBundle.getString("rf.options.export.success.title"),	  g_reminderFoxBundle.getString("rf.options.export.success.description") );
}	

function reminderFox_mergeEvents( existingEvents, importedEvents ) {
	var i;
	for ( i = 0; i < importedEvents.length; i++ ) {
		var exists = reminderFox_eventExists( existingEvents, importedEvents[i] );
		if ( !exists ) {
			// add reminder in sorted order...
			var sortedIndex = reminderFox_getSortedIndexOfNewReminder( existingEvents, importedEvents[i], false );
			reminderFox_insertIntoArray( existingEvents,  importedEvents[i], sortedIndex );
		}
	}
}

function reminderFox_mergeTodos( existingTodos, importedTodos ) {
	var i;
	for ( i = 0; i < importedTodos.length; i++ ) {
		var exists = reminderFox_eventExists( existingTodos, importedTodos[i] );
		if ( !exists ) {
			// add todo in sorted order...
			var sortedIndex = reminderFox_getSortedIndexOfNewTodo( existingTodos, importedTodos[i] );
			reminderFox_insertIntoArray( existingTodos,  importedTodos[i], sortedIndex );
		}
	}
}
function reminderFox_eventExists( existingEvents, importedEvent ) {
		for ( var i = 0; i < existingEvents.length; i++ ) {
			if ( existingEvents[i].id == importedEvent.id ) {
				return true;
			}
		}
		return false;
}
function reminderFox_importReminders() {
    var overWrite = false;
    var flags;
	var msg;
	var buttonPressed;
	var remindersArray;
	var i;
	var todo;
	var reminder;
    
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);

	flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
  	 	promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1 + 
   		promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2;
	msg =  g_reminderFoxBundle.getString("rf.options.import.overwriteoradd.description.1") +"\n" +
		g_reminderFoxBundle.getString("rf.options.import.overwriteoradd.description.2") + "\n" +
		g_reminderFoxBundle.getString("rf.options.import.overwriteoradd.description.3");
	buttonPressed = promptService.confirmEx(window,g_reminderFoxBundle.getString("rf.options.import.overwriteoradd.title"),
	  msg,
	  flags, g_reminderFoxBundle.getString("rf.button.add"), g_reminderFoxBundle.getString("rf.button.cancel"), g_reminderFoxBundle.getString("rf.options.import.overwritebutton.title"), null, {});		  
	  

	// cancel pressed
	if (  buttonPressed == 1 ) {
		return ;
	}
	// overwrite pressed
	if ( buttonPressed == 2 ) {	
		// make sure they REAAAAALY want to overwrite
		flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
   			promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1;     
		msg = g_reminderFoxBundle.getString("rf.options.import.overwrite.description");
		buttonPressed = promptService.confirmEx(window,g_reminderFoxBundle.getString("rf.options.import.overwrite.title"),
		  msg,
		  flags,g_reminderFoxBundle.getString("rf.options.import.overwritebutton.title"), g_reminderFoxBundle.getString("rf.button.cancel"), null, null, {});		  
		  
		// cancel pressed
		if ( buttonPressed == 1 ) {	
			return;
		}	
		overWrite = true;
   }     
        
    //get file
    var file =reminderFox_filePickerImport(1, window);
    if (!file)
      return;
				
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to read file was denied.");
	}

	reminderEvents = new Array();
	reminderTodos = new Array();

	if ( file.path.lastIndexOf( ".txt" ) == file.path.length - ".txt".length ) {
		// import legacy text
		if ( overWrite ) {	
			reminderFox_importLegacyReminders(reminderEvents, reminderTodos, file );
			reminderFoxEvents = reminderEvents;
			reminderFoxTodos = reminderTodos;
		}
		else {
			// add (merge) events
			reminderFox_importLegacyReminders(reminderEvents, reminderTodos, file );		
		
			var existingEvents = reminderFox_getReminderEvents();
			var existingTodos = reminderFox_getReminderTodos();
			// need to merge them
			reminderFox_mergeEvents(existingEvents, reminderEvents  );
			reminderFox_mergeTodos( existingTodos, reminderTodos );
			
			reminderFoxEvents = existingEvents;
			reminderFoxTodos = existingTodos;
		}
	}
	else {
		// ICS
		reminderFox_readInRemindersAndTodosICS(reminderEvents, reminderTodos, file, true);
		if ( overWrite ) {			
			reminderFoxEvents = reminderEvents;
			reminderFoxTodos = reminderTodos;
		}
		else { 
			// merge
			var existingEvents = reminderFox_getReminderEvents();
			var existingTodos = reminderFox_getReminderTodos();
			reminderFox_mergeEvents(existingEvents, reminderEvents  );
			reminderFox_mergeTodos( existingTodos, reminderTodos );
			
			reminderFoxEvents = existingEvents;
			reminderFoxTodos = existingTodos;		
		}
	}
	reminderFox_importRemindersUpdateAll(false, null );
	
	promptService.alert(window,g_reminderFoxBundle.getString("rf.options.export.success.title"),	  g_reminderFoxBundle.getString("rf.options.import.success.description")  );
      
}	

function downloadReminders() {
	reminderFox_saveNetworkOptions();
	window.openDialog('chrome://reminderFox/content/network/download.xul', 'reminderFox-download', 'modal, centerscreen');
}

function uploadReminders() { 
	reminderFox_saveNetworkOptions();
	window.openDialog('chrome://reminderFox/content/network/upload.xul', 'reminderFox-upload', 'modal,centerscreen');
}

function reminderFox_importLegacyReminders(reminderEvents, reminderTodos, file) {
	var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
		.createInstance( Components.interfaces.nsIFileInputStream );
	is.init( file,0x01, 00004, null);

	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
	                          .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = /* The character encoding you want, using UTF-8 here */ "UTF-8";
	
	// Now, read from the stream
	var scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
	                                 .createInstance(Components.interfaces.nsIScriptableInputStream);
	scriptableStream.init(is);
	var chunk = scriptableStream.read(scriptableStream.available());
	var input = null;
	try {
		 input = converter.ConvertToUnicode(chunk);
	}
	catch( e ) {
		// if the conversion fails (say importing from a previous version before the conversion code was in place)
		// then just set the input to the read-in value
		input = chunk;
	}
		 
	var reminders = "";
	remindersArray = reminderFox_splitOnAllNewlines(input);
	var index = 0;
	var readIn = remindersArray[index];

	// bypass header 
	while ( index < remindersArray.length && readIn != "<Reminders>" && readIn != "<ToDo's>" ) {
		index++;
		readIn = remindersArray[index];
	}
	
	// read in reminders
	if ( readIn == "<Reminders>" ) {
		index++;
		reminder = readIn;
		for(index; reminder != "" && reminder != "<ToDo's>" && index< remindersArray.length; index++) {
			reminder = remindersArray[index];
			if ( reminder != "" &&  reminder != "<ToDo's>" ) {
				reminders = reminders + reminder + REMINDER_SEPARATOR;
			}
			else {
				readIn =reminder;
				break;
			}
		}
		// remove trailing separator char
		if ( reminders.lastIndexOf( REMINDER_SEPARATOR ) == reminders.length -1 ) {
			reminders = reminders.substring( 0, reminders.length - 1 );
		} 
	}
	
	// bypass header info
	while ( index < remindersArray.length && readIn != "<Reminders>" && readIn != "<ToDo's>" ) {
		index++;
		readIn = remindersArray[index];
	}
	
	// read in  todos
	var todos= "";
	if ( readIn == "<ToDo's>" ) {
		index++;
		todo = readIn;
		for(index; todo != "" && index< remindersArray.length; index++) {
			todo = remindersArray[index];
			if ( todo != "" ) {
				todos = todos + todo + REMINDER_SEPARATOR;
			}
		}
		// remove trailing separator char
		if ( todos.lastIndexOf( REMINDER_SEPARATOR ) == todos.length -1 ) {
			todos = todos.substring( 0, todos.length - 1 );
		} 
	}
	scriptableStream.close();

	// parse reminders
	var newReminders = "";
//	 if ( !overWrite) {
//		newReminders =  reminderFox_getUnicodePref(REMINDER_FOX_REMINDERS);
//	}
	if ( reminders != "" ) {
		remindersArray = reminders.split(REMINDER_SEPARATOR);
		for(i = 0; i < remindersArray.length; i++) {
			reminder = remindersArray[i];			
			var reminderArray = reminder.split(REMINDER_PROPERTY_DELIMITER);
			
			// account for 1-based offset stored in imported file
			var month = reminderArray[0];
			if ( month  != REMINDER_FOX_MONTHLY_WILDCARD_STR   ) { 
				month = parseInt(reminderArray[0]) - 1;
			}
			
			var newReminder = month;;
			for ( var j=1; j < reminderArray.length; j++ ) {
				newReminder = newReminder + REMINDER_PROPERTY_DELIMITER +  reminderArray[j];
			}
			
			var dayAsInteger = parseInt( reminderArray[1] );
			newReminders = reminderFox_sortNewReminder( newReminders, newReminder, month, dayAsInteger, true );
		}
	}
	
	// parse todos
	var newTodos = "";
//	 if ( !overWrite) {
//		newTodos =  reminderFox_getUnicodePref(REMINDER_FOX_TODOS);
//		if ( todos != "" ) {
//			var todosArray = todos.split(REMINDER_SEPARATOR);
//			for( i = 0; i < todosArray.length; i++) {
//				todo = todosArray[i];
//				
//				if ( todo == newTodos || 
//					 newTodos.indexOf( todo + REMINDER_SEPARATOR ) != -1  || 
//				     newTodos.indexOf( todo + REMINDER_PROPERTY_DELIMITER ) != -1 || 
//					 newTodos.indexOf( REMINDER_SEPARATOR + todo  ) != -1  ) {
//					 // the todo already exists - do nothing
//				}
//				else {
//						newTodos = reminderFox_sortNewTodo( newTodos, todo );
//				}
//			}
//		}
//	}
//	else { 
		// overwrite set - just set newtodos as the value
		newTodos = todos;
//	}

	reminderFox_readInRemindersAndTodos(reminderEvents, reminderTodos, newReminders, newTodos);

//	reminderFox_setUnicodePref(REMINDER_FOX_REMINDERS, newReminders);
//	reminderFox_setUnicodePref(REMINDER_FOX_TODOS, newTodos);
	
	
}




function reminderFox_sortNewTodo( todos, newtodo ) {
	var index;
	var endIndex;
	var j;
	var val ;
	var leftSideOfReminders , rightSideOfReminders;		
	 
	if (todos != "") {
	 	index = 0;
		endIndex = todos.indexOf( REMINDER_SEPARATOR );
		if ( endIndex == -1 ) {
			endIndex = todos.length - 1;
		}
		var added = false;
		
		var newTodoArray = newtodo.split(REMINDER_PROPERTY_DELIMITER);
		
		var isImportant = false;
		var showInTodo = false;
		// check for any options that are specified, and mark them in the columns 
		if ( newTodoArray.length >= 2 ) {
            for ( j = 1; j < newTodoArray.length; j++ ) {
                val = newTodoArray[j];
                if ( val == REMINDER_IMPORTANT_FLAG ) {
                    isImportant = true;        
                }
                else if ( val == REMINDER_TO_BE_COMPLETED_DELIMITER ) {
                    showInTodo = true;        
                } 
            }
        }
     
		// if current todo is not important, add to end of list...
        if ( isImportant ) {
            todos = newtodo + REMINDER_SEPARATOR + todos;
        	added = true;
    
        }
        else {
        	// run through until find one that's not important
    		//todos = todos + REMINDER_SEPARATOR + newtodo;
        	//added = true;
        	
        index = 0;
		endIndex = todos.indexOf( REMINDER_SEPARATOR );
		if ( endIndex == -1 ) {
			endIndex = todos.length - 1;
		}
		//var added = false;
		while ( endIndex != -1 && !added ) {
			var currentReminder = todos.substring( index, endIndex );
			var reminderArray = currentReminder.split(REMINDER_PROPERTY_DELIMITER);
			
			var curImportant = false;
			var curShowInTodo = false;
			if ( reminderArray.length >= 2 ) {
	            for ( j = 1; j < reminderArray.length; j++ ) {
	                val = reminderArray[j];
	                if ( val == REMINDER_IMPORTANT_FLAG ) {
	                    curImportant = true;        
	                }
	                else if ( val == REMINDER_TO_BE_COMPLETED_DELIMITER ) {
	                    curShowInTodo = true;        
	                } 
	            }
	        }
	        
	        if ( !curImportant ) {
	        	if ( showInTodo ) {
	        		// add here
	        		leftSideOfReminders = todos.substring(0, index );						
					rightSideOfReminders = todos.substring(index ,  todos.length);					
					todos = leftSideOfReminders + newtodo + REMINDER_SEPARATOR + rightSideOfReminders;
	        		
	        		added = true;
	        	}
	        	else {
	        		if ( !curShowInTodo ) {
	        			// add here 
	        			leftSideOfReminders = todos.substring(0, index );						
						rightSideOfReminders = todos.substring(index ,  todos.length);					
						todos = leftSideOfReminders + newtodo + REMINDER_SEPARATOR + rightSideOfReminders;
	        			
	        			added = true;
	        		}
	        	}	        
	        }

			index = endIndex + 1;
			endIndex = todos.indexOf( REMINDER_SEPARATOR, index );		
			if ( index != todos.length && endIndex == -1 ) {
				endIndex = todos.length -1;
			}
		}

      }
		
		// if the reminder hasn't been added yet, then place it at the end
		// of the list
		if ( !added ) {
			todos += REMINDER_SEPARATOR + newtodo;
		}			
		
	}	
	else {
		todos += newtodo;
	}	
	return todos;
}


function reminderFox_sortNewReminder( reminders, newreminder, monthInt, dayInt, addUniqueOnly  ) {
	var leftSideOfReminders, rightSideOfReminders;
	
	// We go through each reminder and then compare that reminder's month with 
	// the reminder-to-be-added month, and if the new month is less, add there;
	// if the months are equal, then compare the days and add appropriately. 
	if (reminders != "") {
	 	var index = 0;
		var endIndex = reminders.indexOf( REMINDER_SEPARATOR );
		if ( endIndex == -1 ) {
			endIndex = reminders.length ;
		}
		var added = false;
		while ( endIndex != -1 && !added ) {
			var currentReminder;
			if ( endIndex == reminders.length - 1 ) {
				currentReminder = reminders.substring( index, endIndex + 1 );
			}
			else {
				currentReminder = reminders.substring( index, endIndex );
			}
			var reminderArray = currentReminder.split(REMINDER_PROPERTY_DELIMITER);

			var myMonth;
			var reminderMon;
			// treat Monthly reminders as coming at the end of the list
			if ( monthInt == REMINDER_FOX_MONTHLY_WILDCARD_CHAR ) {
				myMonth = 12;
			}
			else {
			    myMonth = parseInt( monthInt );
			}
			if ( reminderArray[0] == REMINDER_FOX_MONTHLY_WILDCARD_CHAR ) { 
				reminderMon = 12;
			}
			else {
				reminderMon = parseInt(reminderArray[0]);
			}
		
			// add current reminder before reminders from later months
			if (  myMonth < reminderMon) { 
				leftSideOfReminders = reminders.substring(0, index );						
				rightSideOfReminders = reminders.substring(index ,  reminders.length);					
				reminders = leftSideOfReminders + newreminder + REMINDER_SEPARATOR + rightSideOfReminders;
				added = true;
			}
			// if they have the same month, then compare dates
			else if ( reminderMon == myMonth ) {
				var myDay = parseInt(dayInt);
				var reminderDay = parseInt(reminderArray[1]);
				if ( myDay < reminderDay ) {
					leftSideOfReminders = reminders.substring(0, index );							
					rightSideOfReminders = reminders.substring(index ,  reminders.length);					
					reminders = leftSideOfReminders + newreminder + REMINDER_SEPARATOR + rightSideOfReminders;
					added = true;
				}
				else if ( myDay == reminderDay ) {
					var newReminderArray = newreminder.split(REMINDER_PROPERTY_DELIMITER);
					if ( addUniqueOnly && newReminderArray[2] == reminderArray[2] ) {
						// this reminder is already in the list; just ignore it
						added = true;
					}
					else {
						// if this is an Important reminder, add it before other reminders of the same day
						var indexImportant = newreminder.indexOf( REMINDER_PROPERTY_DELIMITER + REMINDER_IMPORTANT_FLAG );
						if ( indexImportant != -1 ) {
							leftSideOfReminders = reminders.substring(0, index );							
							rightSideOfReminders = reminders.substring(index ,  reminders.length);					
							reminders = leftSideOfReminders + newreminder + REMINDER_SEPARATOR + rightSideOfReminders;
							added = true;
						}
					}
				}
			}
			index = endIndex + 1;
			endIndex = reminders.indexOf( REMINDER_SEPARATOR, index );		
			if ( index != reminders.length && endIndex == -1 ) {
				endIndex = reminders.length - 1;
			}
		}
		
		// if the reminder hasn't been added yet, then place it at the end
		// of the list
		if ( !added ) {
			reminders += REMINDER_SEPARATOR + newreminder;
		}	
	}	
	else {
		reminders += newreminder;
	}	
	return reminders;
}

// split a string at newlines:   \n (Mac, *nix) or \r\n  (windows)
function reminderFox_splitOnAllNewlines(input) {
	// just use common newline to read in lines - check for strings that end in \r (to handle windows \r\n)
	var newline = "\n";
	var returnLine = "\r";
	
	var remindersArray = input.split(newline);	
	for ( var index = 0; index < remindersArray.length; index++ ) {
		var readIn = remindersArray[index];	
		if (readIn.length > 0 &&  readIn.lastIndexOf(returnLine) == readIn.length -1 ) {
			readIn = readIn.substring(0, readIn.length -1 );
			remindersArray[index] = readIn;
		}
	}	
	return remindersArray;
}

function reminderFox_pickSoundFile() {
    //get file
    var file =reminderFox_filePickerImportSound(window);
    if (!file)
      return;
   	var soundFilePath = file.path; 
   	document.getElementById("reminderFox-alarm-sound-text-position").setAttribute("value", soundFilePath);
}

function reminderFox_pickFileLocationFile() {
    //get file
    var file =reminderFox_fileLocationPicker( window);
    if (!file)
      return;
   	var fileLocation = file.path; 
   	document.getElementById("reminderFox-file-location").setAttribute("value", fileLocation);
}



function reminderFox_filePickerImport(aOpen, aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(reminderFox_nsIFilePicker);  
    picker.appendFilters( reminderFox_nsIFilePicker.filterText | reminderFox_nsIFilePicker.filterAll );
    picker.appendFilter( filterCalendar, "*" + extensionCalendar );   
    picker.filterIndex=2;
   	picker.defaultExtension = "ics";
    switch (aOpen) {
      case 0:
        picker.init(aWindow, g_reminderFoxBundle.getString("rf.options.export.filepicker.title"), reminderFox_nsIFilePicker.modeSave);
        break;
      case 1:
        picker.init(aWindow,g_reminderFoxBundle.getString("rf.options.import.filepicker.title"), reminderFox_nsIFilePicker.modeOpen);
        break;
    };
    
    // get the file and its contents
    var res = picker.show();
    if (res == reminderFox_nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	



function reminderFox_fileLocationPicker( aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(reminderFox_nsIFilePicker);  
    picker.appendFilters( reminderFox_nsIFilePicker.filterAll );
    picker.appendFilter( filterCalendar, "*" + extensionCalendar );   
    picker.filterIndex=1
   	picker.defaultExtension = "ics";
    picker.init(aWindow, g_reminderFoxBundle.getString("rf.options.filelocation.filepicker.title"), reminderFox_nsIFilePicker.modeOpen);
    
    // get the file and its contents
    var res = picker.show();
    if (res == reminderFox_nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	


function reminderFox_filePickerImportSound(aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(reminderFox_nsIFilePicker);  
    picker.appendFilters(  reminderFox_nsIFilePicker.filterAll );
    picker.appendFilter( filterSound, "*" + extensionSound );   
    picker.filterIndex=1;
   	picker.defaultExtension = "wav";
    picker.init(aWindow, g_reminderFoxBundle.getString("rf.options.sound.filepicker.title"), reminderFox_nsIFilePicker.modeOpen);

    // get the file and its contents
    var res = picker.show();
    if (res == reminderFox_nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	



function reminderFox_filePickerExport(aOpen, aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(reminderFox_nsIFilePicker);  
   
   	picker.defaultExtension = "ics";
    picker.appendFilter( filterCalendar, "*" + extensionCalendar );   
    switch (aOpen) {
      case 0:
        picker.init(aWindow, g_reminderFoxBundle.getString("rf.options.export.filepicker.title"), reminderFox_nsIFilePicker.modeSave);
        break;
      case 1:
        picker.init(aWindow,g_reminderFoxBundle.getString("rf.options.import.filepicker.title"), reminderFox_nsIFilePicker.modeOpen);
        break;
    };
    
    // get the file and its contents
    var res = picker.show();
    if (res == reminderFox_nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	


function reminderFox_concat(c1, c2)
{
  // Concats two collections into an array.
  var c3 = new Array(c1.length + c2.length);
  var x,y = 0;

  for (x = 0; x < c1.length; x++)
    c3[y++] = c1[x];

  for (x = 0; x < c2.length; x++)
    c3[y++] = c2[x];

  return c3;
}

function  reminderFox_populateBars()  {
    // Creates the menuitems for the toolbar selector.
    var win = reminderFox_getWindow();
    var toolbars = win.document.getElementsByTagName("toolbar");
    var statusbars = win.document.getElementsByTagName("statusbar");
    var menubars = win.document.getElementsByTagName("menubar");
    var popup = document.getElementById("reminderFox-popup-bars");
    var x, bar, item, val, list;
    
    // first remove the toolbars already there...
    while (popup.hasChildNodes())
      popup.removeChild(popup.firstChild);
          
    toolbars = reminderFox_concat(toolbars, statusbars);
    toolbars = reminderFox_concat(toolbars, menubars);
    for (x=0; x<toolbars.length; x++) {
      bar = toolbars[x];
      
      //do not include find toolbar
      if (bar.getAttribute("id") == "FindToolbar")
        continue;
             
      item = document.createElement("menuitem");
      item.setAttribute("id", bar.getAttribute("id"));
      item.value = bar.getAttribute("id");         
      if (bar.hasAttribute("toolbarname"))
        item.setAttribute("label", bar.getAttribute("toolbarname"));
      else
        item.setAttribute("label", bar.getAttribute("id"));                 
      popup.appendChild(item);
    }
    
    reminderFox_setElement("reminderFox-list-bars", "general.bar", "Char", "reminderFox-popup-bars");    
  }
function reminderFox_ValidateSynchronization() {
	  var text = document.getElementById("reminderFox-text-address");
	  if ( text.value == null || text.value == "" ) {
	  		document.getElementById("reminderFox_network_import_settings").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox_network_export_settings").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox-network-sync").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox-network-auto-desc").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox-text-username").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox-text-password").setAttribute("disabled", "true");
	  		
	  }
	  else {
	  		document.getElementById("reminderFox_network_import_settings").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox_network_export_settings").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox-network-sync").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox-network-auto-desc").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox-text-username").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox-text-password").removeAttribute( "disabled" );
	  }
	  
	 
}


  function reminderFox_populatePositions()   {
    var barid = document.getElementById("reminderFox-list-bars").selectedItem.getAttribute("id");
    var win = reminderFox_getWindow();
    var bar = win.document.getElementById(barid);

    if (!bar)
      reminderFox_mPositionMax = 0;
    else {
      var len = bar.childNodes.length;
    
      //don't include ourself in count
      if (win.document.getElementById("reminderFox-statusLabel").parentNode == bar)
        len--;
    
      reminderFox_mPositionMax = len;
        
    }

    var val;
	try {
		val = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR_POSITION);
	} catch(e) {
		val = -1;
	}		

    var val2 = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR);
    var text = document.getElementById("reminderFox-text-position");
    var radio = document.getElementsByAttribute("group", "position");
    var group = document.getElementById("reminderFox-group-position");
    var x, el;
    
    //set max value
    text.value = reminderFox_mPositionMax;
    
    //mark always last
    if (val == -1) {
      for (x=0; x < radio.length; x++) {
        if (parseInt(radio[x].value) == val) {
          group.selectedItem = radio[x];
          break;
        }
      }
    }
    
    //mark specific position
    else {
      for (x=0; x < radio.length; x++) {
        if (parseInt(radio[x].value) != -1) {
          group.selectedItem = radio[x];
          break;
        }
      }    
      if (barid != val2) {
        text.value = reminderFox_mPositionMax;
      } else {
        if (val < 0)
          text.value = reminderFox_mPositionMax;
        else if (val > reminderFox_mPositionMax)
          text.value = 0;
        else
          text.value = val; 
      }
    }
    
    // update the error label
    el = document.getElementById("reminderFox-text-position-valid");
    el.setAttribute("value", "(0-"+reminderFox_mPositionMax+")");
  }
  
  function  reminderFox_getWindow()  {
    //XXX may need to change this code if main window of a supported app is not "navigator:browser"
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
    var top = wm.getMostRecentWindow("navigator:browser");
	if ( !top ) {
	 	top = wm.getMostRecentWindow("mail:3pane");
	}
	if ( !top ) {
		top = wm.getMostRecentWindow("mail:messageWindow");
	}
    if (!top) {
    
    var guid;
          try {
        var app = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);    
        guid = app.ID;
      } catch(e) {
        var appBranch = prefService.getBranch(null);
        try {
          guid = appBranch.getCharPref("app.id");
        } catch(e) {
          guid = "{86c18b42-e466-45a9-ae7a-9b95ba6f5640}";
        };    
      };
    
      switch (guid) {
        case "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}":
        case "{3db10fab-e461-4c80-8b97-957ad5f8ea47}":
        default:        
          top = ww.openWindow(null, "chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank");
          break;
        case "{86c18b42-e466-45a9-ae7a-9b95ba6f5640}":
          top = ww.openWindow(null, "chrome://navigator/content/navigator.xul", "_blank", "chrome,all,dialog=no", "about:blank");
          break;
      };
    };
    return top;  
  }
  
  
    function reminderFox_setElement(aName, aPref, aType, aGroup)  {
    var x, el, els, val;
    
    el = document.getElementById(aName);
    
    val = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR);
    //val = eval("this.mBranch.get" + aType + "Pref('" + aPref + "')");
    switch (el.localName) {
      case "checkbox":
        el.checked = val;
        break;
      case "textbox":
        el.value = val;
        break;
      case "menulist":
        els = document.getElementById(aGroup).childNodes;        
        for (x=0; x < els.length; x++) {
          if (((aType == "Int") ? parseInt(els[x].value) : els[x].value) == val) {
            el.selectedItem = els[x];
            break;
          }
        }      
        break;            
      case "radiogroup":
        els = document.getElementsByAttribute("group", aGroup);        
        for (x=0; x < els.length; x++) {
          if (((aType == "Int") ? parseInt(els[x].value) : els[x].value) == val) {
            el.selectedItem = els[x];
            break;
          }
        }      
        break;
    }  
  }
  
function reminderFox_openCustomizeUpcomingLabelWindow() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("window:upcomingLabelOptions");
  
	if (topWindow) {
		topWindow.focus();
   	}
   	else {
   		var newOptions = { variableString:  document.getElementById("upcomingLabelOptions").value }
		window.openDialog("chrome://reminderfox/content/upcomingLabelOptions.xul", "upcomingLabelOptions", "chrome,modal", newOptions);
		document.getElementById("upcomingLabelOptions").value = newOptions.variableString;
		var upcomingLabelPref = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_UPCOMING_REMINDERS_LABEL);
		if (upcomingLabelPref != newOptions.variableString)
			document.getElementById("reminderFox-apply").removeAttribute("disabled");
	}
}

function reminderFox_openCustomizeTodayLabelWindow() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("window:upcomingLabelOptions");
  
	if (topWindow) {
		topWindow.focus();
   	}
   	else {
   		var newOptions = { variableString:  document.getElementById("todaysLabelOptions").value }
		window.openDialog("chrome://reminderfox/content/upcomingLabelOptions.xul", "todaysLabelOptions", "chrome,modal", newOptions);
		document.getElementById("todaysLabelOptions").value = newOptions.variableString;
		var upcomingLabelPref = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TODAYS_REMINDERS_LABEL);
		if (upcomingLabelPref != newOptions.variableString)
			document.getElementById("reminderFox-apply").removeAttribute("disabled");
	}
}

function reminderFox_loadCustomizeUpcomingLabelWindow() {
	var upcomingLabel = window.arguments[0].variableString;
	document.getElementById("upcomingLabelText").setAttribute("value", upcomingLabel);
}

function reminderFox_saveCustomizeUpcomingLabel() {
	var upcomingLabel = document.getElementById("upcomingLabelText").value;
	window.arguments[0].variableString = upcomingLabel;
	window.close();	
}
